#pragma once
#include <stdio.h>
#include <malloc.h>
#include <math.h>

int sum(int a, int b);
int dif(int a, int b);
int mult(int a, int b);
int div(int a, int b);

char* concat(char* w1, char* w2);

int sum(int a, int b)
{
	return a + b;
}

int dif(int a, int b)
{
	return a - b;
}

int mult(int a, int b)
{
	return a * b;
}

int div(int a, int b)
{
	return a / b;
}

char* concat(char* word1, char* word2)
{
	int count1 = 0, count2 = 0;
	while (word1[count1] != '\0') count1++;
	while (word2[count2] != '\0') count2++;

	char* str = (char*)malloc(count1 + count2);

	for (int i = 0; i < count1; i++) str[i] = word1[i];
	str[count1] = ' ';
	for (int i = 0; i < count2; i++) str[count1 + 1 + i] = word2[i];
	str[count1 + 1 + count2] = '\0';
	return str;
}

int strOfInt(char* str, int num)
{
	int sing = 1;
	int i = 0;
	while (str[i] == ' ' || (str[i] != '-' && !(str[i] >= '0' && str[i] <= '9')))
	{
		i++;
	}

	if (str[i] == '-')
	{
		sing = -1;
		i++;
	}
	while (str[i] >= '0' && str[i] <= '9')
	{
		num = num * 10 + (str[i] - '0');
		i++;
	}
	return num * sing;
}

float strOfFloat(char* str, float num)
{
	float sing = 1;
	float frac = 0.1;
	int i = 0;
	while (str[i] == ' ' || (str[i] != '-' && !(str[i] >= '0' && str[i] <= '9')))
	{
		i++;
	}
	if (str[i] == '-')
	{
		sing = -1.0f;
		i++;
	}
	while (str[i] >= '0' && str[i] <= '9')
	{
		num = num * 10.0f + (str[i] - '0');
		i++;
	}
	if (str[i] == '.')
	{
		i++;
		while (str[i] >= '0' && str[i] <= '9')
		{
			num += (str[i] - '0') * frac;
			frac *= 0.1f;
			i++;
		}
		num = num + frac;
	}
	return num * sing;
}

char* toStrI(int num1, char* str)
{
	int negNum = 0;
	if (num1 < 0)
	{
		negNum = 1;
		num1 = fabs(num1);
	}

	int i = 0;
	while (num1 > 0)
	{
		str[i++] = (num1 % 10) + '0';
		num1 /= 10;
	}

	if (negNum)
	{
		str[i++] = '-';
	}
	str[i] = '\0';

	for (int j = 0; j < i / 2; j++)
	{
		char temp = str[j];
		str[j] = str[i - j - 1];
		str[i - j - 1] = temp;
	}
	return str;
}

char* toStrF(float num2, char* str)
{
	int negNum = 0;
	num2 = num2 + 0.00001f;
	if (num2 < 0)
	{
		negNum = 1;
		num2 = fabs(num2);
	}
	int i = 0;
	int integerPart = (int)num2;
	float fracPart = num2 - integerPart;
	int fracPartInt = (int)(fracPart * 1000000 + 0.6);
	if (fracPart > 0)
	{
		for (int j = 0; j < 6; j++)
		{
			str[i++] = (fracPartInt % 10) + '0';
			fracPartInt /= 10;
		}
		str[i++] = '.';
	}

	if (integerPart == 0)
	{
		str[i++] = '0';
	}
	else
	{
		while (integerPart > 0)
		{
			str[i++] = (integerPart % 10) + '0';
			integerPart /= 10;
		}
	}

	if (negNum)
	{
		str[i++] = '-';
	}
	str[i] = '\0';

	for (int j = 0; j < i / 2; j++)
	{
		char temp = str[j];
		str[j] = str[i - j - 1];
		str[i - j - 1] = temp;
	}
	return str;
}